//+------------------------------------------------------------------+
//|           ATR Percentage S/L-T/P .mq4
//|           Modified by ANGUS.                                                       
//|                                                              
//+------------------------------------------------------------------+
#property copyright " "
#property link      " "

#property indicator_chart_window
#property indicator_buffers 5

//---- Input parameters
extern int periods = 377;
extern int percentSL = 100;
extern int percentTP1 = 210;
extern int percentTP2 = 418;
extern int percentTP3 = 610;
extern int corner = 1;

extern int pipMult = 100;


//---- Indicator buffers
double buffera[];
double bufferb[];
double bufferc[];
double bufferd[];

string prefixa = "";
string prefixb = "";
string prefixc = "";
string prefixd = "";


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   if (StringFind(Symbol(),"JPY",0) != -1)
   {
      pipMult = 1;
   }
  {
      int percentagea = percentSL*1;
      prefixa = percentagea + "% ";
   } 
  {
      int percentageb = percentTP1*1;
      prefixb = percentageb + "% ";
   } 
  {
      int percentagec = percentTP2*1;
      prefixc = percentagec + "% ";
   } 
  {
      int percentaged = percentTP3*1;
      prefixd = percentaged + "% ";
   } 

   IndicatorBuffers(4);
   SetIndexBuffer(0,buffera);
   SetIndexBuffer(1,bufferb);
   SetIndexBuffer(2,bufferc);
   SetIndexBuffer(3,bufferd);
   
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexStyle(3,DRAW_NONE);
   
   SetIndexLabel(0,"ATR (" + periods + ")");   
   IndicatorShortName(" S/T P/T ATR (" + periods + ")");
   
   
   ObjectCreate("label_ATRinPipsSL", OBJ_LABEL, 0, 0, 0);
   ObjectCreate("label_ATRinPipsTP1", OBJ_LABEL, 0, 0, 0);
   ObjectCreate("label_ATRinPipsTP2", OBJ_LABEL, 0, 0, 0);
   ObjectCreate("label_ATRinPipsTP3", OBJ_LABEL, 0, 0, 0); 


   ObjectSet("label_ATRinPipsSL", OBJPROP_CORNER, corner );
   ObjectSet("label_ATRinPipsSL", OBJPROP_XDISTANCE, 5);
   ObjectSet("label_ATRinPipsSL", OBJPROP_YDISTANCE, 20);
   
   ObjectSet("label_ATRinPipsTP1", OBJPROP_CORNER, corner );  
   ObjectSet("label_ATRinPipsTP1", OBJPROP_XDISTANCE, 5);
   ObjectSet("label_ATRinPipsTP1", OBJPROP_YDISTANCE, 23+10);
   
   ObjectSet("label_ATRinPipsTP2", OBJPROP_CORNER, corner );
   ObjectSet("label_ATRinPipsTP2", OBJPROP_XDISTANCE, 5);
   ObjectSet("label_ATRinPipsTP2", OBJPROP_YDISTANCE, 23+24);
   
   ObjectSet("label_ATRinPipsTP3", OBJPROP_CORNER, corner );
   ObjectSet("label_ATRinPipsTP3", OBJPROP_XDISTANCE, 5);
   ObjectSet("label_ATRinPipsTP3", OBJPROP_YDISTANCE, 23+38);


//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
   int limit;  
   int counted_bars=IndicatorCounted();
    
//---- Check for possible errors
   if(counted_bars<0) return(-1);
   
//---- Last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars;


      for (int i = 0; i < limit; i++){
         
         
         buffera[i] = iATR(NULL,0,periods,i) * percentSL * pipMult ;
         bufferb[i] = iATR(NULL,0,periods,i) * percentTP1 * pipMult ;
         bufferc[i] = iATR(NULL,0,periods,i) * percentTP2 * pipMult ;
         bufferc[i] = iATR(NULL,0,periods,i) * percentTP3 * pipMult ;
         bufferd[i] = iATR(NULL,0,1,i) * 100 * pipMult ;
      }
      
//-----Comment(prefix, "ATR (", periods, "): ", buffer[0], " pips");
      string textb = prefixa+ "ATR ("+ periods+ ") : "+ DoubleToStr(buffera[0],0)+" pip Stop Loss";
      string texta = prefixb+ "  ATR ("+ periods+ ") : "+ DoubleToStr(bufferb[0],0)+" pip Min Bar";
      string textc = prefixc+ "ATR ("+ periods+ ") : "+ DoubleToStr(bufferc[0],0)+" pip Max Bar";
      string textd = "THIS BAR           " + DoubleToStr(bufferd[0],0)+" pips";
      
      ObjectSetText("label_ATRinPipsSL",textb, 8, "Arial", White);
      ObjectSetText("label_ATRinPipsTP1",texta, 8, "Arial", White);
      ObjectSetText("label_ATRinPipsTP2",textc, 8, "Arial", White);
      ObjectSetText("label_ATRinPipsTP3",textd, 8, "Arial", White);
      
      return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("label_ATRinPipsSL");
   ObjectDelete("label_ATRinPipsTP1");
   ObjectDelete("label_ATRinPipsTP2");
   ObjectDelete("label_ATRinPipsTP3");
   return(0);
  }
  
  
  
//*------------------------------------------------------------------+
//*------------------------------------------------------------------+  

